//+------------------------------------------------------------------+
//|                                                MA Oscillator.mq4 |
//|                                                       Ron Bollig |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Ron Bollig"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Orange
#property indicator_color2 White
#property indicator_color3 Aqua
//---- input parameters
extern int       History   =5000;  // Number of bars to use for calculations
extern int       ST_Period =3;
extern int       ST_Shift  =0;
extern int       ST_Method =0;     //0=SMA,1=EMA,2=SMMA,3=LWMA
extern int       ST_Price  =0;     //0=C,1=O,2=H,3=L,4=Median,5=Typical,6=Weighted close
extern int       LT_Period =10;
extern int       LT_Shift  =0;
extern int       LT_Method =0;     //0=SMA,1=EMA,2=SMMA,3=LWMA
extern int       LT_Price  =0;     //0=C,1=O,2=H,3=L,4=Median,5=Typical,6=Weighted close
extern int       MT_Shift  =15;    //Amount to shift ST Line for MT anticipation
//---- buffers
double ExtMapBuffer1[];  //ST Line
double ExtMapBuffer2[];  //ST Line shifted MT_Shift
double ExtMapBuffer3[];  //MA of ST Line using MT_Shift
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(2,ExtMapBuffer3);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int i=Bars-counted_bars-1;
   if (i>History-1) i=History-1;
   while(i>=0)
     {
     ExtMapBuffer1[i]=iMA(0,0,ST_Period,ST_Shift,ST_Method,ST_Price,i)-iMA(0,0,LT_Period,LT_Shift,LT_Method,LT_Price,i);
     ExtMapBuffer2[i]=ExtMapBuffer1[i+MT_Shift];
     double ST_Total=0;
     int c;
     for(c=1;c<=MT_Shift;c++)
       {
       ST_Total=ST_Total+ExtMapBuffer1[i+(MT_Shift-c)];
       }
     ExtMapBuffer3[i]=ST_Total/MT_Shift;
     i--;
     }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+